// 
// File:   main.cc
// Author: root
//
// Created on 24 gennaio 2008, 18.14
//

#include <stdlib.h>
#include <iostream>

using namespace std;

/*
Esercizio 2
Scrivere un programma che generi due matrice di dimensione mxn e nxk con m, n e k chiesti all'utente.
Inizializzare la matrice nella posizione i,j con il valore i*j
Calcolare il prodotto delle due matrici
Stampare a video la matrice risultante.
Dividere il programma in sottoprogrammi.
Per esempiO:

*/

// Istanzia una matrice mxn e restituisce il puntatore alla memoria allocata

double ** inputMatrice(int m, int n);

// Istanzia una nuova matrice mxk e ne restituisce il puntatore. La matrice mxk conterrà il prodotto delle matrici mat1 (di dimensione mxn) e mat2 (di dimensione nxk).

double ** moltiplicaMatrice(double **mat1, double **mat2, int m, int n, int k);

// Stampa a video la matrice mat di dimensione mxn

void stampaMatrice(double **mat, int m, int k);


int main(int argc, char** argv) {
    int m, n, k;
    m = 4; n = 3; k = 4;
    double **m1 = inputMatrice(m,n);
    double **m2 = inputMatrice(n,k);
    double **m3 = moltiplicaMatrice(m1, m2, m, n, k);
    stampaMatrice(m3, m, k);
    return (EXIT_SUCCESS);
}

double ** inputMatrice(int m, int n){
    double **p;
    p = new double * [m];
    for(int i = 0; i < m; i++){
        *p = new double[n];
        for(int j = 0; j < n; j++){
            *(*p)++ = i * j;
        }
        *p -= n;
        p++;
    }
    p -= m;
    return p;
}
double ** moltiplicaMatrice(double **mat1, double **mat2, int m, int n, int k){
    double **out;
    out = new double * [m];
    for(int i = 0; i < m; i++){
        *out = new double[k];
        for(int j = 0; j < k; j++){
            **out = 0;
            for(int l = 0; l < n; l++){
                **out += *(*mat1 + l) * *(*(mat2 + l) + j);
            }
            (*out)++;
        }
        *out -= k;
        out++;
        mat1++;
    }
    out -= m;
    return out;
}

void stampaMatrice(double **mat, int m, int n){
    for(int i = 0; i < m; i++){
        for(int j = 0; j < n; j++){
            cout << mat[i][j] << " ";
        }
        cout << endl;
    }
    
}
